{}
{ QfelExtendedDialogsPL                                                        }
{ Okienka dialogowe sluce do otwierania i zapisywania plikw graficznych     }
{ (C)1998 by Marcin Qfel Zaleski                                               }
{}
{ QfelPreviewWindow.pas (C)1998 by Marcin Qfel Zaleski                         }
{}
{ 1998-11-17 started                                                           }
{ 1998-11-21 finished                                                          }
{}

unit QfelPreviewWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls;

type
{}
{ TQfelPrevWindow - tool window with always centered image                     }
{}
  TQfelPrevWindow = class(TForm)
      ScrollBox: TScrollBox;
      Image: TImage;
      procedure FormResize(Sender: TObject);
      procedure FormKeyPress(Sender: TObject; var Key: Char);
      procedure FormShow(Sender: TObject);
    private
      FImageMargin : Integer;
    published
      property ImageMargin:Integer read FImageMargin write FImageMargin;
  end;

var
  QfelPrevWindow: TQfelPrevWindow;

implementation

{$R *.DFM}

{==============================================================================}
{ TQfelPrevWindow methods                                                      }
{==============================================================================}

{}
{ FormResize - centre image on form resize                                     }
{}
procedure TQfelPrevWindow.FormResize(Sender: TObject);
var
  ImageLeft : Integer;
  ImageTop  : Integer;
begin
  ScrollBox.HorzScrollBar.Position := 0;
  ScrollBox.VertScrollBar.Position := 0;
  if Image.Width<ScrollBox.ClientWidth then
    ImageLeft := (ScrollBox.ClientWidth - Image.Width) div 2
  else
    ImageLeft := 0;
  if Image.Height<ScrollBox.ClientHeight then
    ImageTop := (ScrollBox.ClientHeight - Image.Height) div 2
  else
    ImageTop := 0;
  Image.SetBounds(ImageLeft,ImageTop,Image.Width,Image.Height);
end;
{}
{ FormKeyPress - close window on <Esc> press                                   }
{}
procedure TQfelPrevWindow.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    Close;
end;
{}
{ FormShow - size window according to image size                               }
{}
procedure TQfelPrevWindow.FormShow(Sender: TObject);
var
  WindowRect : TRect;
  NewWidth   : Integer;
  NewHeight  : Integer;
begin
  WindowRect := Rect(0,0,Image.Width+2*FImageMargin,Image.Height+2*FImageMargin);
  AdjustWindowRectEx(WindowRect,GetWindowLong(Handle,GWL_STYLE),False,GetWindowLong(Handle,GWL_EXSTYLE));
  NewWidth := WindowRect.Right-WindowRect.Left;
  NewHeight := WindowRect.Bottom-WindowRect.Top;
  if (NewWidth<Screen.DesktopWidth) and (NewHeight<Screen.DesktopHeight) then
    begin
      ClientHeight := NewHeight;
      ClientWidth := NewWidth;
    end;
end;

end.
